using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Web;
using System.Web.Services;

using System.IO;

namespace WSDemo2
{
	/// <summary>
	/// Shows how .NET can automatically Serialize Complex DataTypes including Base64 encoding binary data.
	/// </summary>
	public class SerializeTest : System.Web.Services.WebService
	{
		public SerializeTest()
		{
			//CODEGEN: This call is required by the ASP.NET Web Services Designer
			InitializeComponent();
		}

		#region Component Designer generated code
		
		//Required by the Web Services Designer 
		private IContainer components = null;
				
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if(disposing && components != null)
			{
				components.Dispose();
			}
			base.Dispose(disposing);		
		}
		
		#endregion

		/// <summary>
		/// Returns an Array of Strings
		/// </summary>
		[WebMethod]
		public string[] HelloWorlds(int NumberOfWorlds)
		{
			string[] s = new string[NumberOfWorlds];

			for (int i=0; i<NumberOfWorlds; i++)
				s[i] = "Hello World # " + (i+1).ToString();

			return s;
		}

		public enum PictureType
		{
			BennettAdelsonLogo = 1,
			MicrosoftDotNetDevelopmentLogo = 2,
			MicrosoftVisualStudioDotNetLogo = 3
		}

		[ WebMethod(Description="get a picture")]
		public byte[] GetPicture(PictureType pt)
		{
			string fn = string.Empty;

			switch (pt)
			{
				case PictureType.BennettAdelsonLogo:
					fn = "BACWebLogo.JPG";
					break;

				case PictureType.MicrosoftDotNetDevelopmentLogo:
					fn = "MSDotNet.GIF";
					break;

				case PictureType.MicrosoftVisualStudioDotNetLogo:
					fn = "VSDotNet.GIF";
					break;
			}

			if (fn == string.Empty)
				return new byte[0];
			else
			{
				//System.Security.Principal.WindowsImpersonationContext impersonationContext;
				//impersonationContext = ((System.Security.Principal.WindowsIdentity)User.Identity).Impersonate();

				fn = Context.Server.MapPath(fn);
				//fn = Path.Combine(@"C:\Documents and Settings\Administrator\My Documents\My Pictures",fn);
				
				FileStream fs = new FileStream(fn, System.IO.FileMode.Open);
				BinaryReader fi = new System.IO.BinaryReader(fs);
				
				byte[] b = new byte[fs.Length];

				for (int i=0; i<= fs.Length; i += 32000)
				{
					fi.ReadBytes(32000).CopyTo(b,i);
				}

				fi.Close();

				//impersonationContext.Undo();

				return b;
			}
		}			

		public class Employee
		{
			public string Name;
			public decimal Salary;
			public System.DateTime HireDate;
			public string SalaryGrade()
			{
				if (this.Salary <= 65000)
					return "Slave";
				else
					return "Pointy Haired Manager";
			
			}
		}

		[WebMethod]
		public Employee GetEmployee(bool GetManager)
		{
			Employee e = new Employee();

			if (GetManager)
			{
				e.Name = "Mr. Pointy Haired Mgr";
				e.HireDate = DateTime.Now.AddYears(-15);
				e.Salary = 125000;
			}
			else
			{
				e.Name = "Mr. John Q. Programmer";
				e.HireDate = DateTime.Now;
				e.Salary = 52000;
			}

			return e;
		}

		[WebMethod]
		public System.Data.DataSet HelloWorldDataSet()
		{
			DataSet ds = new DataSet("SetName");
			
			DataTable dt = new DataTable("TabName");
			
			dt.Columns.Add("Col1Name",System.Type.GetType("System.Int32"));
			
			ds.Tables.Add(dt);
			
			for (int i=1; i < new System.Random().Next(12); i++) 
				dt.Rows.Add(new object[] {i} );
			
			return ds;
		}
	}
}
