using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace WSDemo2Client
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ListBox listBox1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.ListBox listBox2;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Label label1;

		public static System.Windows.Forms.ListBox MyListBox; //shadows listBox2 so that the static callback can add items to it
		private System.Windows.Forms.Button button2;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// Shadow the listbox with this Static Member so that the CallBack can add items to it.
			//
			Form1.MyListBox = this.listBox2;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.listBox1 = new System.Windows.Forms.ListBox();
			this.button1 = new System.Windows.Forms.Button();
			this.listBox2 = new System.Windows.Forms.ListBox();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.button2 = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// listBox1
			// 
			this.listBox1.Location = new System.Drawing.Point(16, 8);
			this.listBox1.Name = "listBox1";
			this.listBox1.Size = new System.Drawing.Size(256, 82);
			this.listBox1.TabIndex = 0;
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(168, 224);
			this.button1.Name = "button1";
			this.button1.TabIndex = 1;
			this.button1.Text = "Go";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// listBox2
			// 
			this.listBox2.Location = new System.Drawing.Point(16, 96);
			this.listBox2.Name = "listBox2";
			this.listBox2.Size = new System.Drawing.Size(256, 82);
			this.listBox2.TabIndex = 2;
			// 
			// textBox1
			// 
			this.textBox1.Location = new System.Drawing.Point(24, 224);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(144, 20);
			this.textBox1.TabIndex = 3;
			this.textBox1.Text = "1";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(24, 200);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(100, 16);
			this.label1.TabIndex = 4;
			this.label1.Text = "Seconds:";
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(168, 200);
			this.button2.Name = "button2";
			this.button2.TabIndex = 5;
			this.button2.Text = "Clear";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 261);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.button2,
																		  this.label1,
																		  this.textBox1,
																		  this.listBox2,
																		  this.button1,
																		  this.listBox1});
			this.Name = "Form1";
			this.Text = "Form1";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			//Show Demo #1
			//Application.Run(new Form1());

			//Show Demo #2
			Application.Run(new Form2());

			//Show Demo #3
			//Application.Run(new frmDebug());
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			ushort seconds=0;

			//Create the WebService Client Proxy as Generated by WSDL.EXE
			localhost.Service1 s1 = new localhost.Service1();

			//Instantiate an AsyncCallback delegate to use as a parameter
			//in the BeginDelay method.
			AsyncCallback cb = new AsyncCallback(WSCallback);

			// Get Seconds to wait from text box
			try
			{
				seconds = ushort.Parse(textBox1.Text);
			}
			catch
			{
				MessageBox.Show("Please input a number of seconds to wait.");
				return;
			}

			// Begin the Async call to Delay, passing in our
			// AsyncCalback delegate and a reference
			// to our instance of the WebService.
			
			IAsyncResult ar = s1.BeginDelay(seconds, cb, s1);

			listBox1.Items.Add("Waiting for " + seconds.ToString());
		}

		/// <summary>
		/// This method will get called each time an Async WebMethod call completes
		/// </summary>
		/// <param name="ar"></param>
		public static void WSCallback(IAsyncResult ar)
		{
			// You passed in our instance of WebService in the fourth
			// parameter to BeginDelay, which is accessible in the
			// AsyncState property.
			localhost.Service1 s1 = (localhost.Service1) ar.AsyncState;
			

			// Get the completed results.    
			string results = s1.EndDelay(ar);

			Form1.MyListBox.Items.Add(results);
		}

		/// <summary>
		/// Clear the Listboxes
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void button2_Click(object sender, System.EventArgs e)
		{
			listBox1.Items.Clear();
			listBox2.Items.Clear();
		}



	}
}
